#include <stdio.h>
#include <stdlib.h>

/* you must have the following symbols */
/* see John Cresswell document for details : */
/* AGATA PSA and Tracking Algorithm Integration*/
void process_config (char *directory_path, unsigned int *error_code);
struct my_struct *process_register (unsigned int *error_code);
/* the call of this routine is different from the one in the document */
/* because document discribe filter interface and here we consume data */
/* ask X. Grave grave@ipno.in2p3.fr for more details */
void process_block (struct my_struct *algo_data,
                    void *input_buffer,
                    unsigned int size_of_input_buffer,
                    unsigned int *error_code);
/* optionnal symbols */
void process_start (struct my_struct *algo_data,
                    unsigned int *error_code);
void process_stop (struct my_struct *algo_data,
                   unsigned int *error_code);

/* coding region */

static int next_id = 0;
struct my_struct
{
  int id;
};

void process_config (char *directory_path, unsigned int *error_code)
{
  printf ("call to process_config\n");
  printf ("directory path = %s\n",directory_path);
  *error_code = 0;
}

struct my_struct *process_register (unsigned int *error_code)
{
  struct my_struct *algo_data;

  algo_data = (struct my_struct *) malloc (sizeof (struct my_struct));
  algo_data->id = next_id;
  next_id++;
  return algo_data;
}

void process_block (struct my_struct *algo_data,
                    void *input_buffer,
                    unsigned int size_of_input_buffer,
                    unsigned int *error_code)
{
  unsigned int nb_words;
  unsigned int *data;

  data = (unsigned int *) input_buffer;

  nb_words = size_of_input_buffer / 4;
  printf ("start of buffer : %d\n", data[0]);
  printf ("end of buffer : %d\n", data[nb_words - 1]);
  *error_code = 0;
}

void process_start (struct my_struct *algo_data,
                    unsigned int *error_code)
{
  printf ("process_start called with id=%d\n",algo_data->id);
  /* put your code here */
  *error_code = 0;
}
void process_stop (struct my_struct *algo_data,
                   unsigned int *error_code)
{
  printf ("process_stop called with id=%d\n",algo_data->id);
  /* put your code here */
  *error_code = 0;
}
